#ifndef __DirWindow_h
#define __DirWindow_h
//=============================================================================
//
//		Copyright (C) 1995-1997 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//
//=============================================================================
//-----------------------------------------------------------------------------
// DirWindow.h
//
//		Manages window which displays directory listing.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: DirWindow.h,v 1.2 97/02/05 08:13:41 sunshine Exp $
// $Log:		DirWindow.h,v $
// Revision 1.2	 97/02/05  08:13:41	 sunshine
// v29: Added 'writable' flag to prevent cmd-r from working in readonly dirs.
// 
// Revision 1.1	 97/01/12  15:20:06	 sunshine
// v28: Dir window.
//-----------------------------------------------------------------------------
#import <objc/Object.h>
@class Button, MiscTableScroll, TextField, Window;

@interface DirWindow : Object
	{
	MiscTableScroll*	scroll;
	Window*				window;
	Button*				autoSortSwitch;
	Button*				cdButton;
	Button*				dragUnscaledSwitch;
	Button*				hiddenFilesSwitch;
	Button*				highlightSwitch;
	Button*				refreshButton;
	TextField*			countField;
	char*				path;
	BOOL				writable;
	BOOL				autoSort;
	BOOL				dragUnscaled;
	BOOL				highlightDirs;
	BOOL				showHidden;
	}

+ (id)launchDir:(char const*)dirname;

@end

#endif // __DirWindow_h
