/*
  MiscDragScrollWindow.h
  $Id$
  Copyright (c) 1997 Dwight D. Everhart.  All rights reserved.

  This notice may not be removed from this source code.

  This object is included in the MiscKit by permission from the author
  and its use is governed by the MiscKit license, found in the file
  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
  for a list of all applicable permissions and restrictions.
*/

#import <appkit/Window.h>


@class View;


@interface MiscDragScrollWindow: Window

{
   View *scrollingView;
   int sequence;
}

- initContent: (const NXRect *) contentRect style: (int) aStyle
  backing: (int) backingType buttonMask: (int) mask defer: (BOOL) flag;
- free;

- setDragTypes: (const NXAtom *) types count: (int) typeCount;

- enableScrolling: (View *) aView
  forDragSession: (id <NXDraggingInfo>) session;
- disableScrolling;

- (NXDragOperation) draggingEntered: (id <NXDraggingInfo>) sender;
- (NXDragOperation) draggingUpdated: (id <NXDraggingInfo>) sender;
- draggingExited: (id <NXDraggingInfo>) sender;

@end

