/*  Class to act as a cover for Internet addresses.
 *
 *  Copyright (c) 1994, 1996 Christopher J. Kane.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.2 (29 February 1996)
 */

#import <objc/Object.h>
#import <sys/types.h>
#import <netinet/in.h>

@interface MiscINETAddress:Object
{
	struct in_addr address;
	char *hostname;
}

+ localAddress;

- init;
- initFromName:(const char *)name;
- initTo:(struct in_addr)addr;

- (struct in_addr)address;
- (char *)hostname;
- (char *)stringAddress;

// added by Wolfgang_Baron@ixpoint.de

- initBroadcast; // init self to the universal broadcast address
- increment; // increment the address

@end
