/*  Abstract class to act as a cover for sockets.
 *
 *  Copyright (c) 1994, 1996 Christopher J. Kane.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement. Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version 1.2 (29 February 1996)
 */

#import <objc/Object.h>
#import <sys/socket.h>

enum {	/* Values for type parameter */
	MiscSOCK_RAW, MiscSOCK_DGRAM, MiscSOCK_STREAM
};

@interface MiscSocket:Object
{
	int sock;
	int domain;
	int type;
@private
	int initCount;
}

- init;
- initDomain:(int)aDomain type:(int)aType;
- close;
- copyFromZone:(NXZone *)zone;
- free;

- (BOOL)isClosed;
- (int)domain;
- (int)socket;
- (int)type;

@end
