//
//	MiscTextExtensions.h -- extensions to the NeXT Text object
//		Originally written by Scott Anguish
//		Copyright (c) 1994 by Scott Anguish.
//		Modified and extended by Don Yacktman for inclusion into the MiscKit.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

@class MiscString;

#import <appkit/Text.h>

@interface Text(MiscExtensions)

- (MiscString *)getContentString;
- (MiscString *)getSelectionString;
- (MiscString *)getSubstringStringStart:(int)startPos length:(int)numChars;

@end

@interface Text(MiscDExtensions)

// donated by Stefan Bhringer
// Extensions to the Textobject that give convenient access to the text
// and a writenow like keyfilter (which is far from perfect by the way)
- (char *)textAsCopy;
- (MiscString *)textAsString;
- (char *)selectedTextAsCopy;
- (int)lengthOfLineForSel:(NXSelPt *)sel;
- selectWordUnderCaret;

@end

void Misc_installCharFilter(Text *self,NXCharFilterFunc newFilter);

unsigned short Misc_WriteNowCharfilter(unsigned short charCode,int keyFlags,unsigned short charSet);

@interface Text(MiscPrintf)

// donated by Erik M. Buck
- appendText:(const char *)aString;
- printf:(const char *)format,...;
- (char *)stringValue;
- (void)setStringValue:(char *)string;

@end

