//
//	MiscWindowButtons.h -- extension to Window class
//		Written by John Randolph
//		Created: Fri Nov 11 03:43:05 PST 1994
//		Copyright (c) 1994, 1995 by John Randolph.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

/******************************************************************************
  
		 Class: Window
  Category: WindowButtons
		 
Created By:	John C. Randolph,  <jcr@wildrose.com>	(408) 369-8433
						Wildrose Corporation			 
						3438 Fawn Drive
						San Jose, CA 95124
						
	 Created: Tue Apr  4 04:27:33 PDT 1995
	 
    Does:  This category allows a programmer to turn the miniaturize
            and close buttons in a Window's title bar on and off.

    Note: This code relies on unpublished API of the Window class, and
            the FrameView class.  NeXT doesn't even provide a header
            for the FrameView class. I had to figure it out with Eric
            Scott's <eps@cs.sfsu.edu> Class-Dump utility.
						
		Copyright (c) 1995 John C. Randolph
		
		You may use this code any way that you like, but if you use it
		in a commercial application, you owe me dinner.  
		
		All rights reserved.
		
		RESTRICTED RIGHTS LEGEND
		Use, duplication, or disclosure by the Government is subject to
		restrictions as set forth in subparagraph (c) (I) (ii) of the Rights
		in Technical Data and Computer Software Clause at DFARS 252.227-7013.
  
*///---------------------------------------------------------------------------

#import <appkit/appkit.h>

@interface Window (MiscWindowButtons)

- showCloseBox:sender;
- showMiniaturizeButton:sender;
- hideCloseBox:sender;
- hideMiniaturizeButton:sender;

@end
