#import <misckit/_MiscSideSplitView.h>
#import <appkit/appkit.h>

@interface MiscSplitBrowser : _MiscSideSplitView
{	Matrix *leftMatrix,*rightMatrix;
	int		pathSeparator;
	id		target;
	SEL		action;
	SEL		doubleAction;
	id		browserDelegate;
}

- initFrame:(NXRect *) theRect;
- target;
- setTarget:aTarget;
- (SEL)action;
- setAction:(SEL)aAction;
-(SEL) doubleAction;
- setDoubleAction:(SEL)aDoubleAction;
- browserDelegate;
- setBrowserDelegate:aBrowserDelegate;
// if no browser delegate is set this method sets it to theDelegate
// which is then also the SideSplitView delegate
- setDelegate:theDelegate;
- leftView;
- rightView;
- setDivider:(NXCoord) x;

// by the way: NiftyMatrix works fine
+ setMatrixClass:theMatrixClass;
+ matrixClass;

// selection methods
- selectPrevious;
- selectNext;
- acceptArrowKeys:(BOOL) doAccept andSendActionMessages:(BOOL) doSendActions;
- reestablishSelection;		// call this after deletion of a (visible) leaf

// NXBrowser interface
-(char *) getPath:(char *)pathString toColumn:(int) column;
- setPath:(const char *)thePath;
- loadColumnZero;
- loadColumnZeroPreserveSel:(BOOL)preserve;	// nonstandard
-(Matrix*) matrixInColumn:(int) col;
-(int) lastColumn;
-(int) selectedRow;
-(int) selectedColumn;
- (unsigned short)pathSeparator;
- setPathSeparator:(unsigned short)aPathSeparator;
- sendAction;
- reloadColumn:(int) theColumn;
-(Cell *) selectedCell;

- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;
@end
