#ifndef __MiscBorderView_h
#define __MiscBorderView_h
//=============================================================================
//
//		Copyright (C) 1995-1997 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscBorderView.h
//
//		View class for the row/column borders on a MiscTableView.
//		Supports resizing, dragging.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscBorderView.h,v 1.7 97/02/11 19:13:52 sunshine Exp $
// $Log:		MiscBorderView.h,v $
//	Revision 1.7  97/02/11	19:13:52  sunshine
//	v123: reflectSelection --> selectionChanged
//	Now checks isAutodisplay in -selectionChanged.
//	
//	Revision 1.6  96/12/30	16:19:49  zarnuk
//	Added -setFrameHeight:.
//	
//	Revision 1.5  96/09/20	10:32:47  zarnuk
//	Added -resetSelection to fix problems with stale/invalid "oldSel".
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <appkit/View.h>
}
#import <misckit/MiscTableTypes.h>

enum MiscBorderViewType { MISC_COL_BORDER_VIEW, MISC_ROW_BORDER_VIEW };

class MiscSparseSet;
class MiscTableBorder;

@class MiscBorderCell, MiscMouseTracker, MiscTableScroll, MiscTableView;
@class NXCursor;

@interface MiscBorderView : View
	{
	MiscTableScroll*	scroll;
	MiscTableBorder*	info;
	MiscBorderCell*		theCell;
	MiscMouseTracker*	tracker;
	MiscSparseSet*		oldSel;
	MiscCoord_V			togglePos;
	BOOL				isHorz;
	}

- (id)initFrame:(NXRect const*)frameRect
	 scroll:(MiscTableScroll*)scroll
	   info:(MiscTableBorder*)info
	   type:(MiscBorderViewType)type;
- (id)free;

- (MiscPixels)frameHeight;
- (void)setFrameHeight:(MiscPixels)x;
- (void)adjustSize;
- (void)setSelectionMode:(MiscSelectionMode)mode;
- (void)selectionChanged;
- (void)resetSelection;
- (void)drawSlot:(MiscCoord_V)x;

@end

#endif // __MiscBorderView_h
