#ifndef __MiscExporterAccessoryView_h
#define __MiscExporterAccessoryView_h
//=============================================================================
//
//		Copyright (C) 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscExporterAccessoryView.h
//
//		SavePanel accessory view for use by the MiscExporter class.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscExporterAccessoryView.h,v 1.1 96/09/25 11:55:59 zarnuk Exp $
// $Log:		MiscExporterAccessoryView.h,v $
//	Revision 1.1  96/09/25	11:55:59  zarnuk
//	SavePanel accessory view for use by the MiscExporter.
//	
//-----------------------------------------------------------------------------
extern "Objective-C" {
#import <appkit/View.h>
}
#import <misckit/MiscExporter.h>
@class Box, Button;

@interface MiscExporterAccessoryView : View
		{
		Button* formatPop;
		Button* rowTitlePop;
		Button* colTitlePop;
		Button* rowGridPop;
		Button* colGridPop;

		Box*	formatBox;
		Box*	rowTitleBox;
		Box*	colTitleBox;
		Box*	rowGridBox;
		Box*	colGridBox;
		}

- initFrame:(NXRect const*)rect
	format:(MiscExportFormat)format
	rowTitle:(MiscExportTitleMode)rowTitle
	colTitle:(MiscExportTitleMode)colTitle
	rowGrid:(MiscExportGridMode)rowGrid
	colGrid:(MiscExportGridMode)colGrid;
- (MiscExportFormat) format;
- (MiscExportTitleMode) rowTitleMode;
- (MiscExportTitleMode) colTitleMode;
- (MiscExportGridMode) rowGrid;
- (MiscExportGridMode) colGrid;
@end

#endif // __MiscExporterAccessoryView_h
