#ifndef __MiscListTracker_h
#define __MiscListTracker_h
//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscListTracker.h
//
//		List-mode selection tracking.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscListTracker.h,v 1.2 96/05/05 11:07:36 sunshine Exp $
// $Log:		MiscListTracker.h,v $
//	Revision 1.2  96/05/05	11:07:36  sunshine
//	For OpenStep conformance, keyboard events are now treated the same as
//	mouse events (i.e. one must use the same modifiers with keyboard events
//	as one does with mouse events rather than the behavior being different
//	for keyboard events).  Ditched -keyDown:atPos: method.
//	Fixed bug: Was unable to shift-drag to deselect range of slots.
//	
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//-----------------------------------------------------------------------------
#import "MiscMouseTracker.h"

@interface MiscListTracker : MiscMouseTracker
	{
	MiscCoord_V anchor;
	BOOL deselecting;
	}

- (void) mouseDown: (NXEvent const*) event atPos: (MiscCoord_V) pos;
- (void) mouseDragged: (NXEvent const*) event atPos: (MiscCoord_V) pos;
- (void) mouseUp: (NXEvent const*) event atPos: (MiscCoord_V) pos;

@end

#endif // __MiscListTracker_h
