#ifndef __MiscTableScrollPrivate_h
#define __MiscTableScrollPrivate_h
//=============================================================================
//
//		Copyright (C) 1996-1997 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscTableScrollPrivate.h
//
//		Methods used within the Table Scroll palette but which are not
//		exported with the *public* interface.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscTableScrollPrivate.h,v 1.7 97/02/05 07:57:56 sunshine Exp $
// $Log:		MiscTableScrollPrivate.h,v $
// Revision 1.7	 97/02/05  07:57:56	 sunshine
// v122: Added -setTracking: to fix lazy-mode mouse-tracking display problem.
// 
// Revision 1.6	 97/01/24  08:10:26	 sunshine
// v0.119: -setClickedRow: & -setClickedCol: --> -setClickedRow:col:
// Added -resetSelection which calls same in TableView and BorderView.
// Added explicit (id) return and argument types.
// 
// Revision 1.5	 96/12/17  22:24:56	 sunshine
// v112: Added notion of "clicked slot".
//-----------------------------------------------------------------------------
#import <misckit/MiscTableScroll.h>
#import "MiscDelegateFlags.h"

@interface MiscTableScroll (PrivateInternal)

- (id)responsibleDelegate:(MiscDelegateFlags::Selector)cmd;

// Private: border -> scroll
- (char const*)border:(MiscBorderType)b getDelegateSlotTitle:(int)slot;
- (id)border:(MiscBorderType)b getDelegateSlotPrototype:(int)s;

// TableScroll(IncrementalSearch) -> TableScroll(Keyboard)
- (void)keyboardSelect:(NXEvent const*)p;

- (MiscBorderView*)rowTitles;
- (MiscBorderView*)colTitles;

- (void)setTracking:(BOOL)flag;
- (void)setClickedRow:(MiscCoord_P)r col:(MiscCoord_P)c;
- (void)clearClicked;

- (void)resetSelection; // Reset stale-old-selection in Table & Border views.

@end

#endif // __MiscTableScrollPrivate_h
