/* MiscTreeBrowserCell	-- Cell for MiscTreeBrowser
 *
 */

// IMPORTS

#import <appkit/ActionCell.h>
#import <appkit/graphics.h>


// INTERFACE

@interface MiscTreeBrowserCell:ActionCell
{
	id	node;
	unsigned short indentLevel;
	struct _hcFlags {
		unsigned int open:1;
		unsigned int editing:1;
		unsigned int leaf:1;
		unsigned int draggable:1;
	} hcFlags;
}

- init;

- setNode:anObject;
- node;
- (unsigned int)indentLevel;
- nodeAtIndentLevel:(unsigned int)level;

- (const char *)stringValue;
- setStringValue:(const char *)aString;

// Methods used by MiscTreeBrowserMatrix

- (BOOL)isDraggable;
- (NXImage *)dragImage;

- (BOOL)isLeaf;
- (BOOL)isOpen;
- setOpen:(BOOL)flag;

- (BOOL)isEditing;
- setEditing:(BOOL)flag;

- getOpenerRect:(NXRect *)cellFrame inView:controlView;
- getTitleRect:(NXRect *)cellFrame inView:controlView;
- getDragImageRect:(NXRect *)cellFrame inView:controlView;

- sendDoubleAction;

@end
