/* MiscTreeBrowserMatrix
 *
 */

// IMPORTS

#import <appkit/Matrix.h>


// CLASSES

@class MiscTreeBrowserCell, TextField, TextFieldCell;


// INTERFACE

@interface MiscTreeBrowserMatrix:Matrix
{
	TextField *editField;		/*" used to edit cells."*/
	MiscTreeBrowserCell *editCell;	/*" nil, or cell being edited."*/
	TextFieldCell *textCell;	/*" used by  cells for drawing titles."*/
	NXPoint lastPoint;			/*" last point dragged from "*/
	NXCoord nodeIndentWidth;	/*" indent width for child nodes."*/
	NXCoord nodeXMargin;		/*" left margin for nodes. "*/
	short dragCellRow;			/*" if isDraggingCell, row of drag cell "*/
	short toCellRow;			/*" if isDraggingCell, row of dest cell "*/
	short toIndentLevel;		/*" if isDraggingCell, indent in dest cell "*/
	BOOL wasEditing;			/*" YES if user was editing a cell."*/
}

- sharedTextCell;

// EVENT HANDLING

- mouseDown:(NXEvent *)theEvent;
- mouseDragged:(NXEvent *)theEvent;
- mouseUp:(NXEvent *)theEvent;

- keyDown:(NXEvent *)theEvent;

// GENERAL CELL PROPERTIES

- (NXColor)cellColor;
- (NXCoord)nodeIndentWidth;
- (NXCoord)nodeXOffsetForIndent:(int)indent;

// CELL EDITING

- editCell:aCell;
- (BOOL)isEditing;
- endEditing;

// MATRIX EXTENSIONS

- scrollNodeToVisible:aNode;
- selectNode:aNode;

@end
