/* MiscTreeBrowserMatrix
 *
 */

// IMPORTS

#import <appkit/Matrix.h>


// CLASSES

@class MiscTreeBrowserCell, TextField, TextFieldCell;


// INTERFACE

@interface MiscTreeBrowserMatrix:Matrix
{
	TextField *editField;		/*" used to edit cells."*/
	MiscTreeBrowserCell *editCell;	/*" nil, or cell being edited."*/
	TextFieldCell *textCell;	/*" used by  cells for drawing titles."*/
	NXPoint lastPoint;			/*" last point dragged from "*/
	NXCoord nodeIndentWidth;	/*" indent width for child nodes."*/
	short dragCellRow;			/*" if isDraggingCell, row of drag cell "*/
	short toCellRow;			/*" if isDraggingCell, row of dest cell "*/
	short toIndentLevel;		/*" if isDraggingCell, indent in dest cell "*/
	BOOL wasEditing;			/*" YES if user was editing a cell."*/
}

- sharedTextCell;

// EVENT HANDLING

- mouseDownAt:(const NXPoint *)startPoint forCell:(MiscTreeBrowserCell *)aCell;
- mouseDraggedAt:(const NXPoint *)dragPoint forCell:(MiscTreeBrowserCell *)aCell;
- mouseUpAt:(const NXPoint *)lastPoint forCell:(MiscTreeBrowserCell *)aCell;

- keyDown:(NXEvent *)theEvent;

// GENERAL CELL PROPERTIES

- (NXColor)cellColor;
- (NXCoord)nodeIndentWidth;

// CELL EDITING

- editCell:aCell;
- (BOOL)isEditing;
- endEditing;

@end
