#import <misckit/Browser.Dragging.h>

@implementation NXBrowser(DragAccepting)

static id lastCell;

- (NXDragOperation)draggingEntered: sender
{	lastCell=nil;
	return NX_DragOperationGeneric;
}

- (NXDragOperation)draggingUpdated: sender
{	int		 i,x,y;
	Matrix	*cMatrix;
	Cell	*cCell;
	NXPoint	cPoint=[sender draggingLocation],oPoint=cPoint;
	NXRect	cRect;

	for(i=0;cMatrix=[self matrixInColumn:i];i++)
	{	 cPoint=oPoint;
		[cMatrix convertPoint:&cPoint fromView:nil];
		if(cCell=[cMatrix getRow:&y andCol:&x forPoint:&cPoint])
		{	if(cCell &&  (cCell != lastCell))
			{	if(lastCell) [self displayColumn:i];
				lastCell=cCell;
				[cMatrix lockFocus];
				[cMatrix getCellFrame:&cRect at:y:x];
				NXFrameRectWithWidth(&cRect,2);
				[window flushWindow];
				[cMatrix unlockFocus];
			} break;
		}
	} return NX_DragOperationGeneric;

}

- draggingExited:sender
{	[self display];
	return self;
}

- (BOOL)prepareForDragOperation:sender
{	return YES;
}

- (BOOL)performDragOperation:sender
{	if(lastCell)
	{	char path[MAXPATHLEN],*ptr;
		if([self getPath:path toColumn:[self selectedColumn]])
		{	if(!(ptr=strrchr(path,pathSeparator))) ptr=path;
			strcpy(ptr,[lastCell stringValue]);
			[self setPath:path];
			if(target)
			{	if(action)			[target perform:action with:self];
				if(doubleAction)	[target perform:doubleAction with:self];
				if( [target respondsTo:@selector(performDragOperation:)])
					[target performDragOperation:sender];
			}
		} [self display];
	} return YES;
}
- (NXDragOperation)draggingSourceOperationMaskForLocal:(BOOL)flag
{
    return NX_DragOperationAll;
}

@end
