//
//	_MiscGenericLoopPlaceHolder.h -- abstract container used by loop commands
//		Written by Don Yacktman Copyright (c) 1996 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


// A simple data container used to keep track of the status of nested
// foreach commands.

#import <misckit/misckit.h>
#import <misckit/miscmerge.h>

@interface _MiscGenericLoopPlaceHolder : Object
{
	MiscString *variableName;
	MiscString *tag; // to match at the end of the loop
	_MergeEngineTag jumpback;  // where we are in the list

	int position;  // where we are in the list
}

- setVariableName:(MiscString *)aName;
- setTagName:(MiscString *)aName;
- setJumpback:(_MergeEngineTag)aPlace;

- (MiscString *)variableName;
- (MiscString *)tagName;
- (_MergeEngineTag)jumpback;

- setPosition:(int)aPosition;
- (int)position;

@end

@interface MiscMergeEngine (_MiscMergeLoopCommand)

- _loopStack;

@end
