//
//	_MiscMergeForeachCommand.m -- 
//		Written by Don Yacktman Copyright (c) 1996 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import <misckit/miscmerge.h>
#import "_MiscMergeForeachCommand.h"
#import "_MiscMergeLoopCommand.h"
#import "_MiscForEachPlaceHolder.h"

@implementation _MiscMergeForeachCommand

static MiscString *myKey = nil;

- parseFromString:(MiscString *)aString
{
	if (!myKey) {
		myKey = [MiscString new];
		[myKey setStringValue:"foreach"];
	}
	[self eatKeyWord:myKey from:aString isOptional:NO];
	if (varString) [varString free];
	if (tagString) [tagString free];
	varString = [self getArgumentStringFrom:aString toEnd:NO];
	listString = [self getArgumentStringFrom:aString toEnd:NO];
	tagString = [self getArgumentStringFrom:aString toEnd:YES];
	return self;
}

- executeForMerge:(MiscMergeEngine *)aMerger
{	// all we have to do here is set up the loop.  The end command is
	// where all the real work is done.
	id placeHolder = [[_MiscForEachPlaceHolder alloc] init];
	id loopList = [aMerger getField:listString];
	MiscString *startString = [MiscString new];

	// make sure the List is valid
	if ([loopList isKindOf:[List class]]) {
		[startString takeStringValueFrom:[loopList objectAt:0]];
	} else {
		if ([loopList respondsTo:@selector(stringValue)]) {
			[startString takeStringValueFrom:loopList];
		}
		loopList = nil;
	}

	// Build the place holder
	[placeHolder setPosition:0];
	[placeHolder setVariableName:[varString copy]];
	[placeHolder setTagName:[tagString copy]];
	[placeHolder setList:loopList];
	[placeHolder setJumpback:[aMerger currentCommand]];

	// Push it onto the stack
	[[aMerger _loopStack] pushObject:placeHolder];

	// Set the merge variable
	[aMerger setSymbol:[placeHolder variableName] toValue:startString];

	return self;
}

@end
