//
//	_MiscMergeIndexCommand.m -- extract a value from a List variable
//		Written by Don Yacktman Copyright (c) 1996 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import <misckit/miscmerge.h>
#import "_MiscMergeIndexCommand.h"

@implementation _MiscMergeIndexCommand

static MiscString *myKey = nil;

- parseFromString:(MiscString *)aString
{
	if (!myKey) {
		myKey = [MiscString new];
		[myKey setStringValue:"index"];
	}
	[self eatKeyWord:myKey from:aString isOptional:NO];
	value1 = [self getArgumentStringFrom:aString toEnd:NO];
	value2 = [self getArgumentStringFrom:aString toEnd:YES];
	return self;
}

- executeForMerge:(MiscMergeEngine *)aMerger
{
	id theList = [aMerger getField:value1];
	if ([theList isKindOf:[List class]]) {
		[aMerger appendToOutput:[theList objectAt:[value2 intValue]]];
	} else {
		[aMerger appendToOutput:theList];
	}
	return self;
}

@end
