/*
    CategoryPoser.h
    ===============

    John Holdsworth
    Coldwave Programs Ltd.

    This software is in the public domain.

    This category contains a method to find the base class implementation
    of a method that has been overridden by a category. This is used to
    find the original implementation of the +new method of the Appliaction
    class.

*/

#import <objc/Object.h>

@interface Object(CategoryPoser)

+ performOverloadedMethod:(SEL)selector with:anObject;
/* find the original implementation of a class method and perform it */

+ performOverloadedMethod:(SEL)selector;
/* find the original implementation of a class method and perform it */

- performOverloadedMethod:(SEL)selector with:anObject;
/* find the original implementation of an instance method and perform it */

- performOverloadedMethod:(SEL)selector;
/* find the original implementation of an instance method and perform it */

@end
