/*
    prompt.m
    ========

    John Holdsworth
    Coldwave Programs Ltd.

    This software is in the public domain.

    Simple program used in scripts to take response from user 
    Button pressed determines the exit status returned to the script.

    $Log: prompt.m,v $
 * Revision 1.3  1997/04/14  22:45:11  johnh
 * Reversed argument ordering.
 *
 * Revision 1.2  1997/01/23  00:58:42  johnh
 * Tidy up.
 *
 * Revision 1.1  1997/01/19  22:43:59  johnh
 * Initial Version.
 *
*/

#import <appkit/appkit.h>

int main( int argc, char *argv[] )
{
    const char *title = argv[1]; /* title of panel */
    const char *message = argv[2]; /* Text for body of panel */
    const char *ok = argc > 3 ? argv[3] : NULL; /* right hand default button */
    const char *alternate = argc > 4 ? argv[4] : NULL; /* middle button */
    const char *other = argc > 5 ? argv[5] : NULL; /* left hand button */
    Application *app = [Application new]; /* required for panel */
    Panel *panel = NXGetAlertPanel( title, message, ok, alternate, other );

    [app activateSelf:YES]; /* make panel active application */

    switch( [app runModalFor:panel] ) {
    case NX_ALERTDEFAULT:   exit( EXIT_SUCCESS ); /* default button pressed */
    case NX_ALERTALTERNATE: exit( EXIT_FAILURE*1 ); /* middle button pressed */
    case NX_ALERTOTHER:     exit( EXIT_FAILURE*2 ); /* left button pressed */
    case NX_ALERTERROR:     exit( EXIT_FAILURE*3 ); /* some kind of error */
    }

    exit( EXIT_FAILURE*4 ); /* very wierd error */
}
