/*
    reload.m
    ========

    John Holdsworth
    Coldwave Programs Ltd.

    This software is in the public domain.

    A simple program to message the distributed object server named
    in the first argument with the path provided in the second.

    $Log: reload.m,v $
 * Revision 1.3  1997/04/14  21:38:43  johnh
 * Class of proxy changed.
 *
 * Revision 1.2  1997/01/23  00:58:54  johnh
 * Tidy up.
 *
 * Revision 1.1  1997/01/19  22:44:12  johnh
 * Initial Version.
 *
*/

#import "../CategoryLoader.h" // to pick up reloadBundle: method.

#import <remote/NXConnection.h> // DO proxy...

int main( int argc, char *argv[] )
{
    const char *loaderName = argv[1]; // Distributed application object name
    const char *bundlePath = argv[2]; // path to bundle that should be loaded
    NXProxy *proxy = [NXConnection connectToName:loaderName];

    if( proxy == (NXProxy *)0 ) {
	fprintf( stderr, "Unable to connect to Distributed Object %s\nIs application running?\n\n", loaderName );
	exit( EXIT_FAILURE*2 );
    }
    else if( [(CategoryLoader *)proxy reloadBundle:bundlePath] != YES ) {
	fprintf( stderr, "Unable load bundle %s\n\n", bundlePath );
    	exit( EXIT_FAILURE*1 );
    }

    exit( EXIT_SUCCESS ); // Bundle loaded OK.
}
