/*
    service.m
    =========

    John Holdsworth
    Coldwave Programs Ltd.

    This software is in the public domain.

    Simple program to call services from scripts.
    Button pressed determines the exit status.

    $Log: service.m,v $
 * Revision 1.2  1997/01/23  00:59:07  johnh
 * Tidy up.
 *
 * Revision 1.1  1997/01/19  22:44:21  johnh
 * Initial Version.
 *
*/

#import <appkit/appkit.h>

int main( int argc, char *argv[] )
{
    const char *itemName = argv[1]; /* name of service top be called */
    const char *fileName = argv[2]; /* filename to be passed to service */
    Pasteboard *pasteboard = [Pasteboard new];
    static const char *types[1];
    int len = strlen( fileName );

    [Application new]; /* necessary for services to work */

    types[0] = NXFilenamePboardType; // to write filename to Pasteboard

    [pasteboard declareTypes:types num:1 owner:nil]; 
    [pasteboard writeType: NXFilenamePboardType data:fileName  length:len];

    if( NXPerformService( itemName, pasteboard ) != YES )
	exit( EXIT_FAILURE );

    exit( EXIT_SUCCESS );
}
