// -*- objc -*-

#import <appkit/appkit.h>

#define MAX_ITER         256

@interface MainController : Object
{
    id mandelWindow;
    id mandelView;
    id mandelForm;
    int *rawMandelData;
    int mandelWidth;
    int mandelHeight;
    double minMandelX;
    double maxMandelX;
    double minMandelY;
    double maxMandelY;

    id juliaWindow;
    id juliaView;
    id juliaForm;
    id juliaQForm;
    int *rawJuliaData;
    int juliaWidth;
    int juliaHeight;
    double juliaQX;
    double juliaQY;
    double minJuliaX;
    double maxJuliaX;
    double minJuliaY;
    double maxJuliaY;

    id colorMerge;
    NXColor *colorTable;

    id infoPanel;
}

- appDidInit: sender;

- setGrayColorTable: sender;
- setColorColorTable: sender;

- changeMergeMode: sender;

- saveImage: sender;

- setMandelParams: sender;
- setMandelDefaults: sender;

- setJuliaParams: sender;
- setJuliaQ: sender;
- setJuliaDefaults: sender;

- calcColorTable;

- calcRawMandelData;
- calcRawJuliaData;

- calcMandelImageRep;
- calcJuliaImageRep;

- displayParams;

- imageView: sender sizedTo: (NXCoord) width : (NXCoord) height;

- imageView: sender mouseDown: (NXCoord) x : (NXCoord) y;
- imageView: sender mouseDragged: (NXCoord) y : (NXCoord) y;

- colorMergeDidChange: sender;

- windowWillMiniaturize: sender toMiniwindow: miniwindow;

- showInfoPanel: sender;

@end
