// Tue Oct 15 06:52:10 MET 1996 by Daniel Bhringer, All rights reserved

// this is not useful for building Netscape derivatives (since it is not
// error-tolerant and tables and backgroundimages are in pre-alpha-state; frames do not work at all),
// but for rapid forms-prototyping and powerful intranet solutions. (EmbeddedHTML)
// scenario: you convert sort of multimedia data from other platforms (e.g. M$'s .mvb) to html using
//			 a powerful perl scipt and then write a display-client for NS using this Textclass category.
// also useful for creating rtfd-docs (including NeXT-style links) programmatically
// or showing .html- based helpfiles in NS4.x-apps (somebody still has to build a MiscHelpPanel though)

// note that background images are only partly supported (better do not use)
// and form-objects not yet print in a smart way using the dingbats font.

#import <appkit/appkit.h>
#import <misckit/misckit.h>

#import "HTMLCells.h"
#import "NXMarkerCell.h"


@interface Text(HTMLExtensions)

- setFromHTML:(const char *)htmlString andDelete:(BOOL) doClear;
- setFromHTML:(const char *)htmlString;

// these are private
- sharedField;
- setSharedButton:theButton;

@end


// for url support and httpd-emulation the textDelegate has to implement the following
// informal protocol:
@interface Object(HTMLTextDelegation)

// if file=="///SameFile///" then use -findMarker:markername on the current text-object
// otherwise you will have to parse file as an URL
- showFile:(const char *) file atMarker:(const char *) markerName openInNewWin:(BOOL) flag;

// if not implemented, the image corresponding to theFile on the local filesystem gets displayed
-(NXImage*) getImageForFile:(const char*) theFile;

// should forward to the appropriate window
- setTitle:(const char *) aTitle;

@end


@interface Text(TextWarningSuppression)
// hidden NeXT-utility method uncovered (MiscClass-decoded):
// selects and scrolls visible the line of the marker spelling someSearch
- findMarker:(const char*) someSearch;
@end